package com.upyuns.platform.rs.website.biz;


import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.util.Query;
import com.upyuns.platform.rs.website.dto.ApiDocDTO;
import com.upyuns.platform.rs.website.entity.ApiCustomNode;
import com.upyuns.platform.rs.website.entity.ApiDoc;
import com.upyuns.platform.rs.website.entity.OrderItem;
import com.upyuns.platform.rs.website.mapper.ApiCustomNodeMapper;
import com.upyuns.platform.rs.website.mapper.ApiDocMapper;


import com.upyuns.platform.rs.website.vo.ApiDocTreeVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import tk.mybatis.mapper.entity.Example;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 */
@Service
public class ApiDocBiz extends BaseBiz<ApiDocMapper, ApiDoc>{


    @Resource
    private ApiCustomNodeMapper nodeMapper;

    public ObjectRestResponse getTree() {
        Example exampleDoc = new Example(ApiDoc.class);
        Example exampleNode = new Example(ApiCustomNode.class);
        exampleDoc.createCriteria()
                .andEqualTo("isDel", 0);
        List<ApiDocTreeVo> docTreeVoList = new ArrayList<>();
        for (ApiDoc apiDoc : mapper.selectByExample(exampleDoc)) {
            exampleNode.createCriteria()
                    .andEqualTo("isDel",0)
                    .andEqualTo("docId",apiDoc.getId());
            exampleNode.excludeProperties("respondJson");
            List<ApiCustomNode> nodes = nodeMapper.selectByExample(exampleNode);
            ApiDocTreeVo vo = new ApiDocTreeVo();
            BeanUtils.copyProperties(apiDoc,vo);
            vo.setNodeList(nodes);
            docTreeVoList.add(vo);
            exampleNode.clear();
        }
        return ObjectRestResponse.succ(docTreeVoList);
    }

    public ObjectRestResponse getTreeByType(Integer type) {
        Example example = new Example(ApiDoc.class);
        example.createCriteria()
                .andEqualTo("docType",type)
                .andEqualTo("isDel", 0);
        return ObjectRestResponse.succ(mapper.selectByExample(example));
    }

    public ObjectRestResponse getList(ApiDocDTO apiDocDTO) {
        Query query = new Query(apiDocDTO);
        Example exampleNode = new Example(ApiCustomNode.class);
        List<ApiDocTreeVo> docTreeVoList = mapper.selectList(query.getSuper());
        for (ApiDocTreeVo apiDocTreeVo : docTreeVoList) {
            exampleNode.createCriteria()
                    .andEqualTo("isDel",0)
                    .andLike("nodeName",'%'+apiDocDTO.getKeyWord()+'%')
                    .andEqualTo("docId",apiDocTreeVo.getId());
            exampleNode.excludeProperties("respondJson");
            apiDocTreeVo.setNodeList(nodeMapper.selectByExample(exampleNode));
            exampleNode.clear();
        }
        return ObjectRestResponse.succ(docTreeVoList);
    }
}




